//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: header.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

var title;
var iHeight = 0;

setTimeout('setZoomed(0)', 500);
var count_getZoomed = 0;
var timer_getZoomed = null;

function setTitle(text)
{
  if (title)
  {
    //title.innerText = text;
    var temp_text = text;
    var i = temp_text.indexOf('G5 ');
    if (i != -1)
    {
      if (i < 12)
        temp_text = temp_text.replace('G5 ', '<img src="theme/spacer.gif" /> ');
    }
    title.innerHTML = temp_text;
  }
}

function setLoading(isLoading)
{
}

function onTab(url)
{
  var buttons = document.querySelector("#header").getElementsByTagName("li");
  for (var i = 0, j = buttons.length; i < j; i++)
    buttons[i].style.display = 'block';
}

function onGoto(url)
{
  var buttons = document.querySelector("#header").getElementsByTagName("li");
  for (var i = 0, j = buttons.length; i < j; i++)
    buttons[i].style.display = 'none';
}

function init()
{
  title = document.querySelector(".title");

  var header = document.querySelector("#header");
  if (header)
  {
    // Prevent scrolling on this element
    header.ontouchmove =
      function(event)
      {
        event.preventDefault();
      }
  }
  if (title)
  {
    setTitle(title.innerText);
  }
  changeCssClass();
}

function changeCssClass()
{
  var div_header = document.getElementById("header");
  var body = document.querySelector("body");
  var attr = div_header.getAttribute('class');
  var flag = false;
  if (attr == null)
    attr = '';
  //#TODO: optimize letter
  if (attr.indexOf('big') == -1 && attr.indexOf('small') == -1)
  {
    var add_atrr = 'big';
    if (window.localStorage.getItem('xpromo.ui.header.size') == 25)
      add_atrr = 'small';
    if (attr != '')
    {
      attr += ' ' + add_atrr;
    }
    else
    {
      attr = add_atrr;
    }
    div_header.setAttribute('class', attr);
    getZoomed(0);
  }
}

function getZoomed(a) {
  if (a == undefined || a == null)
    a = 0;
  var ih = window.innerHeight;
  if (ih == 0)
  {
    a++;
    window.clearTimeout(timer_getZoomed);
    timer_getZoomed = window.setTimeout('getZoomed(' + a + ')', 500);
  }
  /*else
  if (ih > iHeight)
  {
    alert('ih=' + ih);
    iHeight = ih;
    window.clearTimeout(timer_getZoomed);
    timer_getZoomed = setTimeout('getZoomed(' + a + ')', 500);
  }*/
  else
  if(ih == 240)
  {
    window.clearTimeout(timer_getZoomed);
    timer_getZoomed = window.setTimeout('getZoomed(' + a + ')', 500);
  }
  else
  if (ih < iHeight)
  {
    window.clearTimeout(timer_getZoomed);
    timer_getZoomed = window.setTimeout('getZoomed(' + a + ')', 500);
  }
  else
  {
    iHeight = ih;
    var def = window.localStorage.getItem('xpromo.ui.header.size');
    if (def != null)
    {
      var userAgent = navigator.userAgent.toLowerCase();
      var pixelRatio = window.devicePixelRatio;
      if (pixelRatio == undefined)
        pixelRatio = 1;
      var zm = ih / def;
      if (zm > 2)
        zm = 2;
      zm = zm * pixelRatio;
      var self_id = window.localStorage.getItem('xpromo.id');
      window.localStorage.setItem('xpromo.ui.zoom', zm);
      count_getZoomed++;
      window.clearTimeout(timer_getZoomed);
      if (count_getZoomed < 10)
      {
        timer_getZoomed = window.setTimeout('getZoomed(0)', 500);
      }
      else
      {
        timer_getZoomed = window.setTimeout('getZoomed(0)', count_getZoomed * 1000);
      }
    }
  }
}

// Fire on load
window.addEventListener("load", init, false);
