//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: follow.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

function subscribeMessage(needLang, flagHtml) {
  var scripts = document.getElementsByTagName('script');
  var i = 0;
  for(var b in scripts)
  {
    if (scripts[b].src != undefined)
    {
      if(scripts[b].src.indexOf('follow.js') != -1)
      {
        i = b;
        break;
      }
    }
  }
  var path = scripts[i].src.split('?')[0];
  var mydir = path.split('/').slice(0, -2).join('/')+'/';
  var xmlhttp = new XMLHttpRequest();
  var txt = '';
  with(xmlhttp)
  {
    open("GET", mydir + "subscribe.html", false);
    send(null);
    txt = responseText;
  }
  var address = '';
  var arrayTranslate = new Object();
  var myReAdress = /<address>(.*?)<\/address>/igm;
  var myReHTML = /<html(\s|\S)*?<\/html>/igm
  var myReLang = /<html(?:\s)*?lang=(?:'|")(\w+)(?:'|")>/ig
  var myReTitle = /<title>(.*?)<\/title>/ig
  var myRePre = /<pre>((?:\s|\S)*)<\/pre>/igm
  var myReBody = /<body((?:\s|\S)*)<\/body>/igm
  var htmlArr = txt.match(myReHTML);
  var tmp;
  for (var b in htmlArr)
  {
    tmp = myReLang.exec(htmlArr[b]);
    if (tmp == null)
    {
      if (address == '')
      {
        tmp = myReAdress.exec(htmlArr[b]);
        address = tmp[1];
      }
    }
    else
    {
      arrayTranslate[tmp[1]] = htmlArr[b].replace(myReLang, '<html>');
    }
    myReLang.exec('');
  }
  var retMessage = arrayTranslate[needLang];
  if (retMessage == undefined)
    retMessage = arrayTranslate['en'];
  tmp = myReTitle.exec(retMessage);
  var title = tmp[1];
  if (flagHtml)
  {
    tmp = myReBody.exec(retMessage);
    retMessage = tmp[0];
  }
  else
  {
    tmp = myRePre.exec(retMessage);
    retMessage = tmp[1];
  }
  return {'address': address, 'subject': title, 'body': retMessage}
}

function subscribeParam(_param, _default)
{
  var result = window.localStorage.getItem(_param);

  if (!result)
    result = _default;

  return result;
}

function subscribeExec() {
  var lang     = subscribeParam("xpromo.lang", window.location.search.get("lang"));
  var platform = subscribeParam("xpromo.platform", window.location.search.get("plat"));
  var udid     = subscribeParam("xpromo.udid",     window.location.search.get("udid"));
  var flag_html = false;
  if (platform == "iPhone" || platform == "iPad")
    flag_html = true;
  var lockit   = subscribeMessage(lang, flag_html);
  var result   = "mailto:" + lockit.address;
  result += "?subject=" + lockit.subject;

  if (platform)
    result += " (" + platform + ")";

  if (udid)
  {
    if (flag_html)
    {
      lockit.body += "<br/>\n " + udid + " ";
    }
    else
    {
      lockit.body += "\n\n\n " + udid + " ";
    }
  }
  
  if (flag_html)
    lockit.body = "<html><body>" + lockit.body + "</body></html>";

  result += "&body=" + lockit.body;

  result = encodeURI(result).replace(",", "%2C"); // for old xpromo clients
  location.href = "@ext(" + result + ")";
}

function mainModal(_url)
{
  window.open(_url, "_blank", "width=800px, height=600px");
}


