//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: games.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

var GAMES_NEW_DATE = new Date((new Date().getTime()) - 1000 * 60 * 60 * 24 * 42);
var isIpadNew = false;

with (window.localStorage)
{
  if (getItem("xpromo") == null ||
      getItem("xpromo") == "test")
  {
    setItem("xpromo",                "test");
    setItem("xpromo.id",             "com.g5e.xpromodemo");
    setItem("xpromo.games.self.id",  "com.g5e.xpromoapp");
    setItem("xpromo.games.count",  "39");
    setItem("xpromo.games.0.id",  "com.fgames.lsoul.hd");
    setItem("xpromo.games.1.id",  "com.g5e.virtualcitysb.hd");
    setItem("xpromo.games.2.id",  "com.jetdogs.sinistercity.hd");
    setItem("xpromo.games.3.id",  "com.g5e.standofood3.hd");
    setItem("xpromo.games.4.id",  "com.g5e.letters2.hd");
    setItem("xpromo.games.5.id",  "com.g5e.smm2.hd");
    setItem("xpromo.games.6.id",  "com.g5e.standofood.hd");
    setItem("xpromo.games.7.id",  "com.realore.janeshotel2.hd");
    setItem("xpromo.games.8.id",  "com.g5e.mahjonga1.hd");
    setItem("xpromo.games.9.id",  "com.g5e.virtualcity2.hd");
    setItem("xpromo.games.10.id",  "com.g5e.islandcastaway.hd");
    setItem("xpromo.games.11.id",  "com.g5e.letters.hd");
    setItem("xpromo.games.12.id",  "com.g5e.virtualcity.hd");
    setItem("xpromo.games.13.id",  "com.g5e.sstory.hd");
    setItem("xpromo.games.14.id",  "com.g5e.jack.hd");
    setItem("xpromo.games.15.id",  "com.g5e.crossworlds.hd");
    setItem("xpromo.games.16.id",  "com.g5e.mahjonga2.hd");
    setItem("xpromo.games.17.id",  "com.g5e.specialenquiry.hd");
    setItem("xpromo.games.18.id",  "com.g5e.smm.hd");
    setItem("xpromo.games.19.id",  "com.g5e.treasures3.hd");
    setItem("xpromo.games.20.id",  "com.g5e.sm.hd");
    setItem("xpromo.games.21.id",  "com.g5e.crystalportal.hd");
    setItem("xpromo.games.22.id",  "com.orchidgames.royaltrouble.hd");
    setItem("xpromo.games.23.id",  "com.g5e.paranormal.hd");
    setItem("xpromo.games.24.id",  "com.g5e.fiu2.hd");
    setItem("xpromo.games.25.id",  "com.g5e.youdasurvivor.hd");
    setItem("xpromo.games.26.id",  "com.g5e.spiritofwondering.hd");
    setItem("xpromo.games.27.id",  "com.g5e.magicianbook.hd");
    setItem("xpromo.games.28.id",  "com.g5e.treasures1.hd");
    setItem("xpromo.games.29.id",  "com.g5e.treasureseekers4.hd");
    setItem("xpromo.games.30.id",  "com.g5e.crystalportal2.hd");
    setItem("xpromo.games.31.id",  "com.g5e.fiu80.hd");
    setItem("xpromo.games.32.id",  "com.g5e.ts2.hd");
    setItem("xpromo.games.33.id",  "com.g5e.xpromoapp.hd");
    setItem("xpromo.games.34.id",  "com.g5e.fiu.hd");
    setItem("xpromo.games.35.id",  "com.g5e.romanceofrome.hd");
    setItem("xpromo.games.36.id",  "com.g5e.mushroomage.hd");
    setItem("xpromo.games.37.id",  "com.g5e.kbrawe.hd");
    setItem("xpromo.games.38.id",  "com.realore.dressuprush.hd");
    setItem("xpromo.recomend.count",  "4");
    setItem("xpromo.recomend.0.id",  "com.g5e.virtualcity.hd");
    setItem("xpromo.recomend.1.id",  "com.g5e.crossworlds.hd");
    setItem("xpromo.recomend.2.id",  "com.g5e.xpromoapp.hd");
    setItem("xpromo.recomend.3.id",  "com.g5e.virtualcitysb.hd");
  }
}

var dataRecommended = {};
var dataMore        = {};
var dataNew         = {};

var gamesDirective = 
{
  "li" : 
  {
    "game<-games" : 
    {
      "@class+"   : function(arg) {
        var ret = '';
        if(arg.item.kind != undefined)
          ret += arg.item.kind;
        var z = arg.pos % 4;
        var t = arg.pos % 2;
        if(t == 0)
          ret += ' left-colum';
        if(z > 1)
          ret += ' odd';
        if(Math.ceil((arg.pos + 1) / 2) == Math.ceil(arg.length / 2))
          ret += ' last-line';
        ret += ' ' + arg.item.genre;
        ret += ' ' + getPlatformFromId(arg.item.id);
        return ret;
      },
      "b p.title"        : "game.name",
      "a@href" : function(arg) {
        var GRID = 10987;
        var flag = true;
        var ret = '';
        if(arg.item.kind != undefined)
        {
          if(arg.item.kind == 'coming')
            flag = false;
        }
        if (flag)
        {
          if(arg.item.links.free != undefined)
          {
            ret = convertLink('@ext(' + arg.item.links.free + ')', GRID);
          }
          else if(arg.item.links.lite != undefined)
          {
            ret = convertLink('@ext(' + arg.item.links.lite + ')', GRID);
          }
          else if(arg.item.links.full != undefined)
          {
            ret = convertLink('@ext(' + arg.item.links.full + ')', GRID);
          }
          else if(arg.item.links.download != undefined)
          {
            ret = convertLink('@ext(' + arg.item.links.download + ')', GRID);
          }
        }
        if (ret == '')
          ret = 'javascript:subscribeExec()';

        return ret;
      },
      "div.ico@style" : function(arg) {
        return "background-image: url(" + arg.item.id + "/" + iconNameFor(arg.item.id) + ")";
      },
      "div.ico@alt_img" : function(arg) {
        if(isIpadNew)
        {
          return arg.item.id;
        }
        return '';
      },
      "div.link@class+" : function(arg) {
        var ret = '';
        if(arg.item.kind != undefined)
        {
          if(arg.item.kind == 'coming')
            ret = 'notify';
        }
        if(ret == '')
        {
          if(arg.item.links != undefined)
          {
            if(arg.item.links.free != undefined || arg.item.links.lite != undefined || arg.item.links.full != undefined || arg.item.links.download != undefined)
              ret = 'free';
          }
        }
        if(ret == '')
          ret = 'notify';
        return ' ' + ret;
      },
      "p.red@onclick" : function(arg) {
        var ret = 'game.html?this=' + arg.item.id;
        ret = "simulateClick('" + ret + "');return false";
        return ret;
      }
    }
  }
}

for (id in xpromoGames)
{
  try
  {
    var game  = xpromoGames[id];

    game.id   = id;
    game.date = new Date(game.date);

    if (game.date > GAMES_NEW_DATE)
      game.kind = "new";

    if (!("doomed" in game))
      game.doomed = 0;
  }
  catch (e)
  {
    delete xpromoGames[id];
  }
}

function simulateClick(a) {
  window.location.href = a;
}
function gamesSelfId()
{
  var result = window.localStorage.getItem("xpromo.games.self.id");
  if (null == result)
    result = window.localStorage.getItem("xpromo.id");

  return result;
}

function gamesLoadGame(_table, _id)
{
  var game = _table[_id];

  if (!game || !(lockit = lockitLoad(_id + "/index")))
  {
    console.log("not found: " + _id);
    game = null;
  }
  else
  {
    game.name       = lockit["title"];
    game.name_short = lockit["title_short"] || game.name;
    game.links      = lockit["#links"];
    game.genre      = lockit["genre"].toLowerCase();
  }

  return game;
}

function gamesInit(_table)
{
  isIpadNew = isIpadNewFunc();
  var games = new Array(parseInt(window.localStorage.getItem("xpromo.games.count")));
  for (var i = 0; i < games.length; i++)
    games[i] = gamesLoadGame(_table, 
      window.localStorage.getItem("xpromo.games." + i + ".id"));
  // filter unavailable games
  games = games.filter(function(element, index, array)
  {
    return element != null;
  });
  var preRecomended = new Array();
  preRecomended.id = new Array();
  var len = parseInt(window.localStorage.getItem("xpromo.recomend.count"));
  var tmp;
  for(var i = 0; i < len; i++)
  {
    tmp = window.localStorage.getItem("xpromo.recomend." + i + ".id");
    if(tmp != null)
      preRecomended.id[preRecomended.id.length] = tmp;
  }
  var self_id = gamesSelfId();
  var genre = 'st';
  var game = gamesLoadGame(xpromoGames, gamesSelfId());
  if(game.genre != undefined)
  {
    if(game.genre == 'adv')
      genre = game.genre;
  }
  if(games.length > 4)
  {
    games = games.filter(function(element, index, array)
    {
      return element.id != self_id;
    });
  }
  preRecomended.games = games.filter(function(element, index, array)
  {
    return inArray(element.id, preRecomended.id);
  });
  var dataComing = {};
  var currentDate = new Date();
  dataComing.games = games;
  dataComing.games = dataComing.games.filter(function(element, index, array)
  {
    if(element.date > currentDate)
    {
      return true;
    }
    else if(element.links != undefined)
    {
      if(element.links.length > 0)
        return true;
    }
    return false;
  });
  //change kind of games
  for(var b in games)
  {
    if(dataComing.games.indexOf(games[b]) != -1)
      games[b].kind = 'coming';
  }
  for(var b in dataComing.games)
    dataComing.kind = 'coming';
  dataComing.games.sort(function(a, b)
  {
    b = (b.doomed == -1) ? new Date(0) : b.date;
    a = (a.doomed == -1) ? new Date(0) : a.date;

    return b - a;
  });
  dataNew.games = games.slice(0);
  dataNew.games = dataNew.games.filter(function(element, index, array) 
  {
    return -1 == dataComing.games.indexOf(element);
  });
  dataNew.games.sort(function(a, b)
  {
    b = (b.doomed == -1) ? new Date(0) : b.date;
    a = (a.doomed == -1) ? new Date(0) : a.date;

    return b - a;
  });
  i = dataComing.games.length;
  i = parseInt(i);
  //dataNew.games = dataComing.games.concat(dataNew.games);
  dataNew.games = dataNew.games.slice(0, 4 - i);
  dataNew.games = dataNew.games.concat(dataComing.games);
  dataMore.games = games;
  dataMore.games = dataMore.games.filter(function(element, index, array) 
  {
    return (-1 == dataNew.games.indexOf(element)) && (-1 == preRecomended.games.indexOf(element));
  });
  
  //dataMore.games = dataMore.games.slice(4);
  var gamesMyGenre = {};
  var gamesAnotherGenre = {};
  gamesMyGenre.games = dataMore.games.filter(function(element, index, array)
  {
    return element.genre == genre;
  });
  gamesAnotherGenre.games = dataMore.games.filter(function(element, index, array)
  {
    return -1 == gamesMyGenre.games.indexOf(element);
  });
  dataMore.games = gamesMyGenre.games.concat(gamesAnotherGenre.games);
  
  dataRecommended.games = preRecomended.games.concat(dataMore.games.slice(0, 4));
  dataRecommended.games = dataRecommended.games.slice(0, 4);
  dataRecommended.games.sort(function(a, b)
  {
    b = (b.doomed == -1) ? new Date(0) : b.date;
    a = (a.doomed == -1) ? new Date(0) : a.date;

    return b - a;
  });
  dataMore.games = dataMore.games.filter(function(element, index, array) 
  {
    return -1 == dataRecommended.games.indexOf(element);
  });
  
  //dataNew.games.reverse();
  return games;
}

function gamesRender()
{
  setZoomed(0, 1);
  gamesInit(xpromoGames);

  $p("h4#New + ul").autoRender(dataNew, gamesDirective);
  $p("h4#Recommended + ul").autoRender(dataRecommended, gamesDirective);
  $p("h4#More + ul").autoRender(dataMore, gamesDirective);
  var z;
  if (dataMore.games.length == 0)
  {
    var section = $p("h4#More")[0];
    section.parentNode.removeChild(section);
    if(dataRecommended.games.length == 0)
    {
      section = $p("h4#Recommended")[0];
      section.parentNode.removeChild(section);
      z = (dataNew.games.length - 1) % 4;
    }
    else
    {
      z = (dataRecommended.games.length - 1) % 4;
    }
  }
  else
  {
    z = (dataMore.games.length - 1) % 4;
  }
  if(z > 1)
  {
    var hs2 = document.getElementById('hack_separator2');
    if(hs2 != null)
    {
      hs2.setAttribute('class', 'odd');
    }
  }
  setTimeout('fixNew()', 10);
  if(isIpadNew)
    preloadBigImage();
}

function fixNew() {
  var sel = $p("h4#New + ul li");
  var tmp;
  for(var i = 0; i < sel.length; i++)
  {
    tmp = sel[i].className;
    tmp = tmp.replace('game_ ', 'game_new ');
    sel[i].className = tmp;
  }
  sel = $p("h4#Recommended + ul li");
  i = sel.length - 1;
  tmp = sel[i].className;
  tmp = tmp.replace('game_new ', 'game_ ');
  sel[i].className = tmp;
}

function preloadBigImage() {
  var arr_load = new Array();
  var tmp;
  var sel = $p('div.ico');
  var i;
  var XPROMO_SITE = "http://xpromo.g5e.com/v1/";
  for(i = 0; i < sel.length; i++)
  {
    tmp = sel[i].getAttribute('alt_img');
    if(getPlatformFromId(tmp) == 'ipad')
    {
      if(!inArray(tmp, arr_load))
        arr_load.push(tmp);
    }
  }
  if(arr_load.length > 0){
    var img = document.createElement('img');
    img.addEventListener('load', function(){
      for(i = 0; i < sel.length; i++)
      {
        tmp = sel[i].getAttribute('alt_img');
        if(tmp == arr_load[0])
        {
          sel[i].style.backgroundImage = 'url(' + XPROMO_SITE + arr_load[0] + '/icon-big.jpg)';
          sel[i].removeAttribute('alt_img')
        }
      }
      arr_load.shift();
      sel = $p('div.ico')
      if(arr_load[0])
        img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg';
    }, false);
    img.src = XPROMO_SITE + arr_load[0] + '/icon-big.jpg';
  }
}

function replaceSort(arr, flag) {
  var arr_doomed, arr_middle, arr_top;
  arr_doomed = arr.filter(function(element, index, array)
  {
    return (element.doomed < 0);
  });
  if (flag)
  {
    arr_doomed.sort(function(a, b)
    {
      return b.date - a.date;
    });
  }
  if (flag)
  {
    arr_middle = arr.filter(function(element, index, array)
    {
      return (element.doomed == 0);
    });
    arr_middle.sort(function(a, b)
    {
      return b.date - a.date;
    });
    arr_top = arr.filter(function(element, index, array)
    {
      return (element.doomed > 0);
    });
    arr_top.sort(function(a, b)
    {
      return b.date - a.date;
    });
    var ret = new Array();
    var i;
    for (var b in arr_top)
    {
      i = arr_top[b].doomed - 1;
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_top[b];
    }
    i = 0;
    for (var b in arr_middle)
    {
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_middle[b];
    }
    for (var b in arr_doomed)
    {
      while(ret[i] != undefined)
        i++;
      ret[i] = arr_doomed[b];
    }
  }
  else
  {
    arr_middle = arr.filter(function(element, index, array)
    {
      return (element.doomed > -1);
    });
    var ret = arr_middle.concat(arr_doomed);
  }
  return ret;
}