//-------------------------------------------------------------------
//
//  This code is copyright 2012 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: news_config.js
//  Description: 
//       Author: Voronoy S. (sergey.voronoy@g5e.com)

var XPROMO_SITE = "http://xpromo.g5e.com/v1/";
var NEWS_SITE   = XPROMO_SITE + "news/";
var get = getGet();

function galleryRender()
{
  var text, i;
  if(get)
  {
    text = newsLoadLang(get);
    if(text == null)
    {
      return false;
    }
    else
    {
      text = lockitGet(text);
    }
  }
  if(text)
  {
    var selecti = document.querySelectorAll('IMG');
    if(text['gallery'] != undefined)
    {
      for(i = 0; i < text['gallery'].length; i++)
      {
        if(checkVar(text['gallery'][i]))
        {
          selecti[i].src = text['gallery'][i];
        }
        else
        {
          removeNode(selecti[i]);
        }
      }
    }
  }
  return true;
}
function newsRender()
{
  var GRID = 10987;
  var text, temp_text, i;
  if(get)
  {
    text = newsLoadLang(get);
    if(text == null)
    {
      return false;
    }
    else
    {
      text = lockitGet(text);
    }
  }
  if(text)
  {
    var selectn = Array('#title_news', '#common', '#banner', '#icon', '#global_div', '#countbox', '#countbox H3', '#youtube');
    var selecti = Array();
    var lang = lockitGetLang();
    for(i = 0; i < selectn.length; i++)
    {
      selecti[selectn[i]] = document.querySelectorAll(selectn[i])[0];
    }
    if(checkVar(text['title']))
    {
      document.title = text['title'];
    }
    if(checkVar(text['title_news']))
    {
      selecti['#title_news'].innerHTML = text['title_news'];
    }
    else
    {
      removeNode(selecti['#title_news']);
    }
    temp_text = '';
    if(text['common'] != undefined)
    {
      if(checkVar(text['common']['text']))
        temp_text += text['common']['text'];
      if(checkVar(text['common']['button_text']) && checkVar(text['common']['button_href']))
        temp_text += '<br><br><a href="' + convertLink(text['common']['button_href'], GRID) + '">' + text['common']['button_text'] + '</a>';
    }
    if(temp_text > '')
    {
      selecti['#common'].innerHTML = temp_text;
    }
    else
    {
      removeNode(selecti['#common']);
    }
    temp_text = '';
    if(text['banner'] != undefined)
    {
      if(checkVar(text['banner']['src']) && checkVar(text['banner']['href']))
        temp_text = '<a href="' + convertLink(text['banner']['href'], GRID) + '"><img src="' + text['banner']['src'] + '"/></a>';
    }
    if(temp_text > '')
    {
      selecti['#banner'].innerHTML = temp_text;
    }
    else
    {
      removeNode(selecti['#banner']);
    }
    temp_text = '';
    if(text['icon'] != undefined)
    {
      if(checkVar(text['icon']['src']) && checkVar(text['icon']['href']))
        temp_text = '<img src="' + text['icon']['src'] + '" border="0"/>'
    }
    if(temp_text > '')
    {
      selecti['#icon'].innerHTML = temp_text;
      selecti['#icon'].href = convertLink(text['icon']['href'], GRID);
    }
    else
    {
      removeNode(selecti['#icon']);
      selecti['#global_div'].style.marginLeft = '5%';
    }
    temp_text = '';
    var dca;
    if(text['countdown'] != undefined)
    {
      if(text['countdown']['date'] != undefined)
      {
        dca = text['countdown']['date'].split('-');
        if(dca.length == 3)
        {
          var countdown = new Date(dca[0], dca[1] - 1, dca[2]);
          var now = new Date();
          if(countdown >= now)
          {
            if(checkVar(text['countdown']['title']))
              temp_text = text['countdown']['title'];
          }
        }
      }
    }
    if(temp_text > '')
    {
      selecti['#countbox H3'].innerHTML = temp_text;
      countdownStartUp(lang.toUpperCase(),dca[0],dca[1],dca[2]);
    }
    else
    {
      removeNode(selecti['#countbox']);
    }
    if(text['gallery'] != undefined)
    {
      var img_gal = document.querySelectorAll('#gallery A');
      var img_gal2;
      for(i = 0; i < img_gal.length; i++)
      {
        if(checkVar(text['gallery'][i]))
        {
          img_gal[i].href = 'galleryr.html?f=' + get + '#' + (i+1);
          img_gal2 = img_gal[i].querySelectorAll('IMG')[0];
          img_gal2.src = text['gallery'][i];
        }
        else
        {
          removeNode(img_gal[i]);
        }
      }
    }
    else
    {
      var img_gal = document.querySelectorAll('#gallery A');
      var img_gal2;
      for(i = 0; i < img_gal.length; i++)
      {
        removeNode(img_gal[i]);
      }
    }
    temp_text = '';
    if(checkVar(text['youtube']))
    {
      if(document.querySelectorAll('.android BODY').length > 0)
      {
        selecti['#youtube'].innerHTML = '<a href="vnd.youtube:' + text['youtube'] + '"><img class="video" style="background-image: url(http://img.youtube.com/vi/' + text['youtube'] + '/0.jpg);background-position:center center;width: 100%; height: auto;-webkit-background-size: 100% auto;" src="../theme/youtube_play.png"/></a>';
      }
      else if(document.querySelectorAll('.mac BODY').length > 0)
      {
        selecti['#youtube'].innerHTML = '<iframe class="youtube-player" type="text/html" src="http://www.youtube.com/embed/' + text['youtube'] + '" frameborder="0" width="100%" height="195" style="border: 1px solid #fff; margin:0;"></iframe>';
      }
      else
      {
        selecti['#youtube'].innerHTML = '<EMBED src="http://www.youtube.com/v/' + text['youtube'] + '" type="application/x-shockwave-flash" wmode="window" width="100%" height="196" allowFullScreen="true"/>';
      }
    }
    else
    {
      removeNode(selecti['#youtube']);
    }
  }
  return true;
}

function checkVar(a)
{
  if(a != undefined)
  {
    if(a.length > 0)
      return true;
  }
  return false;
}

function removeNode(elem)
{
  return elem.parentNode.removeChild(elem);
}

function newsLoadLang(name_config)
{
  var xmlhttp = new XMLHttpRequest();
  with (lockitXHR)
  {
    open("GET", NEWS_SITE + get + ".txt", false);
    send(null);
    if (responseText)
    {
      try
      {
        return JSON.parse(responseText.replace(/[\r\n]/g, ''));
      }
      catch (e)
      {
        console.log(e);
      }
    }
  }
  
  return null;
}

function getGet()
{
  var get = window.location.search.get("f");
  var tmp_string = new String(window.location);
  var x;
  x = tmp_string.lastIndexOf('/');
  if(x != -1)
  {
    NEWS_SITE = tmp_string.substring(0, x + 1);
  }
  if(get != null)
  {
    return get;
  }
  else
  {
    return false;
  }
}